﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.ScheduleView;
using System.ComponentModel;
using Telerik.Windows.Controls;

namespace LightSwitchApplication
{
	public class CustomAppointment : Appointment, IDataErrorInfo
	{
		private Product product;
		public Product Product
		{
			get
			{
				return this.Storage<CustomAppointment>().product;
			}
			set
			{
				var storage = this.Storage<CustomAppointment>();
				if (storage.product != value)
				{
					storage.product = value;
					this.OnPropertyChanged(() => this.Product);
					//OnPropertyChanged("Product");
				}
			}
		}

		public override IAppointment Copy()
		{
			var newAppointment = new CustomAppointment();
			newAppointment.CopyFrom(this);
			return newAppointment;
		}

		public override void CopyFrom(IAppointment other)
		{
			var task = other as CustomAppointment;
			if (task != null)
			{
				this.Product = task.Product;
			}
			base.CopyFrom(other);
		}

		public string Error
		{
			get 
			{
				return this.ValidateProduct();
			}
		}

		public string this[string columnName]
		{
			get 
			{
				switch (columnName)
				{ 
					case "Product":
						return ValidateProduct();
				}
				return null;
			}
		}

		private string ValidateCustomAppointment()
		{
			return ValidateProduct();
		}

		private string ValidateProduct()
		{
			if (this.Product == null)
			{
				return "Product cannot be null!";
			}
			return null;
		}

		protected override void OnPropertyChanged(string propertyName)
		{
			base.OnPropertyChanged(propertyName);

			if (propertyName == "Product")
			{
				CommandManager.InvalidateRequerySuggested();
			}
		}
	}
}
